#Methods

##Implementation

TicTimer first has the user set up the details for a session, then it runs a clock for the specified session time while writing significant events to a log file. The program writes a line to the log file for each of the following events: session started and ended, tic detected, ten seconds passed without tics, and reward dispensed. Each line includes the time of the event. By parsing through each line in a log file, a python script can extract and summarize the key data.

The hardware allows reward tokens to be dispensed automatically to the study participant. 
One end of the long cable enters the token dispenser and its two wires attach to the two pins in the 
Passive Connection Panel that, when shorted, trigger release of a reward token. The Student Trainer Interface box provides power to the token dispenser box and a remote pushbutton for manually triggering token release. The other end of the long cable connects to the two normally open pins on the relay inside of the small plastic box. The USB to TTL serial cable attaches to the input pins on 
the relay, with the USB end of the cable leaving the box to attach to the computer running TicTimer. The figure shows the final assembly.

Parts List:
* Med Associates token dispenser box, Part #ENV-703
* Med Associates SG-595 Student Trainer Interface
* Med Associates SG-215D3 Passive Connection Panel
* 5V Relay module [(SainSmart part # 20-018-100)](http://www.microcenter.com/product/437842/2-Channel_5V_Relay_Module)
* USB to TTL serial cable [(Adafruit part # 954)](http://www.microcenter.com/product/454433/USB_to_TTL_Serial_Cable)
* Plastic project enclosure box [(Velleman part # WCAH2855)](http://www.microcenter.com/product/428753/PLASTIC_PROJECT_BOX,_BLACK_ABS)
* ~6m cable with at least one pair of wires free

##Operation

System software requirements are Java 8 and RXTX for Java, a library for serial port communication. Binaries for Windows and Linux are provided by [Fizzed.com](http://fizzed.com/oss/rxtx-for-java). Python 3 was used for the log file reader script.

The program can be run with or without the relay and USB cable. If the hardware is set up and connected to the computer, the program can start in "link mode." Otherwise, TicTimer can still be run in "button mode," in which the automatic reward system is replaced by a human who presses the push button attached to the Student Trainer Interface when prompted by a beep and a red flash on the computer screen. 

The following procedure applies to both reward modes. First, the user presses "Setup" to choose which type of session is being run and to specify where the session log should be saved. For the NCR condition, the user is also prompted to identify the log file from a previously completed DRO session in the same subject (which provides the timing for the rewards dispensed in the NCR condition). Once setup is completed, the session can be started. During a session, the person observing the subject records tics by clicking the "Tic Detected" button or by pressing "T" or the space bar. If the session type includes rewards (DRO and NCR), they are dispensed appropriately. The session ends when the predetermined time elapses or when the user ends it manually by pressing "End Session" or by closing the window. 

If a session is ended manually and restarted, the new session log will be appended to the old one unless a new file was chosen in setup. If a log file contains multiple sessions, only the last session will be used by the NCR mode (which requires a DRO session file in setup) and the data reader script.

To summarize the data from a TicTimer log file, run the accompanying python scrypt (TT_Data.py) with one or more log files as arguments. For each log file given, the script reports the length of the session and the number of tics, 10-second tic-free intervals, and rewards dispensed during the session.
